#include <sourcemod>
#include <cstrike>
#pragma semicolon 1

#define PLUGIN_VERSION "1.0.0.0"
public Plugin:myinfo = {
	name 		= "No Weapon Spawn",
	author 		= "Alex The Regent",
	description = "Позволяет поставить лимит на покупку оружия и задержку для покупки оружия",
	version 	= PLUGIN_VERSION,
	url 		= "http://all4css.ru/"
};

new Handle:	g_hConVar_iMaxPrimaryBought;
new			g_iMaxPrimaryBought;
new Handle:	g_hConVar_iMaxSecondaryBought;
new			g_iMaxSecondaryBought;
new Handle:	g_hConVar_iBuyDelay;
new			g_iBuyDelay;

new Handle:	g_hTrie_IngoreWeapons;
new Handle:	g_hTrie_Pistols;
new			g_iPrimaryBuyTime[MAXPLAYERS+1];
new			g_iPrimaryBought[MAXPLAYERS+1];
new			g_iSecondaryBuyTime[MAXPLAYERS+1];
new			g_iSecondaryBought[MAXPLAYERS+1];

public OnPluginStart()
{
	g_hTrie_IngoreWeapons = CreateTrie();
	SetTrieValue(g_hTrie_IngoreWeapons, "vest", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "vesthelm", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "nvgs", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "flashbang", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "hegrenade", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "smokegrenade", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "defuser", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "primammo", 1);
	SetTrieValue(g_hTrie_IngoreWeapons, "secammo", 1);
	
	g_hTrie_Pistols = CreateTrie();
	SetTrieValue(g_hTrie_Pistols, "glock", 1);
	SetTrieValue(g_hTrie_Pistols, "usp", 1);
	SetTrieValue(g_hTrie_Pistols, "p228", 1);
	SetTrieValue(g_hTrie_Pistols, "deagle", 1);
	SetTrieValue(g_hTrie_Pistols, "elite", 1);
	SetTrieValue(g_hTrie_Pistols, "fiveseven", 1);
	
	CreateConVarEx(g_hConVar_iMaxPrimaryBought, "sm_nws_maxprim", "5", "Максимальное число возможных покупок винтовок за раунд");
	CreateConVarEx(g_hConVar_iMaxSecondaryBought, "sm_nws_maxsec", "5", "Максимальное число возможных покупок пистолетов за раунд");
	CreateConVarEx(g_hConVar_iBuyDelay, "sm_nws_buydelay", "1", "Время в секундах, как часто можно покупать (для пистолетов и винтовок раздельное время)");
	AutoExecConfig(true, "no_weapon_spam");
	
	HookEvent("round_start", Ev_RoundStart);
}

CreateConVarEx(&Handle:hConVar, String:sName[], String:sValue[], String:sText[])
{
	hConVar = CreateConVar(sName, sValue, sText, FCVAR_PLUGIN);
	HookConVarChange(hConVar, OnConVarChange);
}

public OnConVarChange(Handle:hConVar, const String:sOldValue[], const String:sNewValue[])
{
	if ( hConVar == g_hConVar_iMaxPrimaryBought )
	{
		g_iMaxPrimaryBought = GetConVarInt(g_hConVar_iMaxPrimaryBought);
	}
	else if ( hConVar == g_hConVar_iMaxSecondaryBought )
	{
		g_iMaxSecondaryBought = GetConVarInt(g_hConVar_iMaxSecondaryBought);
	}
	else if ( hConVar == g_hConVar_iBuyDelay )
	{
		g_iBuyDelay = GetConVarInt(g_hConVar_iBuyDelay);
	}
}

public OnConfigsExecuted()
{
	g_iMaxPrimaryBought = GetConVarInt(g_hConVar_iMaxPrimaryBought);
	g_iMaxSecondaryBought = GetConVarInt(g_hConVar_iMaxSecondaryBought);
	g_iBuyDelay = GetConVarInt(g_hConVar_iBuyDelay);
}

public OnClientPutInServer(iClient)
{
	g_iPrimaryBuyTime[0] = 0;
	g_iPrimaryBought[0] = 0;
	g_iSecondaryBuyTime[1] = 0;
	g_iSecondaryBought[0] = 0;
}

public Ev_RoundStart(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{
	for ( new i = 1; i <= MaxClients; ++i )
	{
		g_iPrimaryBuyTime[i] = 0;
		g_iPrimaryBought[i] = 0;
		g_iSecondaryBuyTime[i] = 0;
		g_iSecondaryBought[i] = 0;
	}
}

public Action:CS_OnBuyCommand(iClient, const String:sWeaponName[])
{
	decl iBuffer;
	if ( GetTrieValue(g_hTrie_IngoreWeapons, sWeaponName, iBuffer) )
	{
		return Plugin_Continue;
	}
	
	if ( GetTrieValue(g_hTrie_Pistols, sWeaponName, iBuffer) )
	{
		if ( g_iSecondaryBought[iClient] > g_iMaxSecondaryBought )
		{
			PrintToChat(iClient, "Вы достигли лимит покупок пистолетов в этом раунде");
			return Plugin_Handled;
		}
		else
		{
			new iTime = GetTime();
			if ( iTime - g_iSecondaryBuyTime[iClient] < g_iBuyDelay )
			{
				PrintToChat(iClient, "Вы слишком часто покупаете оружие");
				return Plugin_Handled;
			}
			g_iSecondaryBuyTime[iClient] = iTime;
			g_iSecondaryBought[iClient]++;
		}
	}
	else
	{
		if ( g_iPrimaryBought[iClient] > g_iMaxPrimaryBought )
		{
			PrintToChat(iClient, "Вы достигли лимит покупок винтовок в этом раунде");
			return Plugin_Handled;
		}
		else
		{
			new iTime = GetTime();
			if ( iTime - g_iPrimaryBuyTime[iClient] < g_iBuyDelay )
			{
				PrintToChat(iClient, "Вы слишком часто покупаете оружие");
				return Plugin_Handled;
			}
			g_iPrimaryBuyTime[iClient] = iTime;
			g_iPrimaryBought[iClient]++;
		}
	}
	
	return Plugin_Continue;
}